---
updatedAt: 2026-09-22T20:15:37.000Z
agentTools:
  projectIndex: https://apidocs.klipfolio.com/llms.txt
---

# Data Source Instances Data

If a data source is a dynamic data source it will have more than one instance associated with it. A data source that has one instance will use the same ID for both the data source and the data source instance.

## GET /datasource-instances/\{id}/data

|              |                                                                                                                                         |
| :----------- | :-------------------------------------------------------------------------------------------------------------------------------------- |
| Description  | Get the details for the specific data source ID.                                                                                        |
| Permissions  | dashboard.library                                                                                                                       |
| Resource URL | <https://app.klipfolio.com/api/1.0/datasource-instances/{id}/data>                                                                      |
| Parameters   | id (string) - data source instance id&#xD;<br />(optional) client\_id (string) - show only instances belonging to the specified client. |

## Example Request

```text Get datasource instance data
GET https://app.klipfolio.com/api/1/datasource-instances/0123456789abcdef0123456789abcdef/data
```
```text Client get datasource instance data
```

## Example Response

```
{
"data": {
   ga:continent,ga:visitors,ga: visits,ga: pageviews
   (not set),16,36,286
   Africa,157,545,3717
   Americas,4058,11956,105724
   Asia,824,2154,22109
   Europe,2102,8511,85399
   Oceania,544,2084,18580
},
"meta": {
   "status": 200,
   "success": true
}
}
```

## PUT /datasource-instances/\{id}/data

|              |                                                                                                                                                               |
| :----------- | :------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| Description  | Update the specified data source instance with data. Works with files and with raw data. For web accessible data sources use POST /@/refresh to get new data. |
| Permissions  | dashboard.library                                                                                                                                             |
| Resource URL | <https://app.klipfolio.com/api/1.0/datasource-instances/{id}/data>                                                                                            |
| Parameters   | id (string) - data source instance id<br />(optional) client\_id (string) - update only instances belonging to the specified client.                          |

## Example Request

```text Update datasource instance data
PUT https://app.klipfolio.com/api/1/datasource-instances/0123456789abcdef0123456789abcdef/data -d "<filename>"
```
```text Client update datasource instance data
```

## Example Response:

```
{ "meta": { "success": true, "status": 200 }, "data": { } }
```